// 
//  This code is part of FreeWeb - an FCP-based client for Freenet
//
//  Designed and implemented by David McNab, david@rebirthing.co.nz
//  CopyLeft (c) 2001 by David McNab
//
//  The FreeWeb website is at http://freeweb.sourceforge.net
//  The website for Freenet is at http://freenet.sourceforge.net
//
//  This code is distributed under the GNU Public Licence (GPL) version 2.
//  See http://www.gnu.org/ for further details of the GPL.
//

//////////////////////////////////////////////////////
// FreeWeb Publisher
//
// global constants


#define MAXCONCURRENTINSERTS	6	/* max freenet inserts happening at once */
//#define MAXCONCURRENTINSERTS	1	// for debugging
//#define SINGLE_THREAD			1	// define to force single-thread inserts

#define LOG_FILE				"freeweb.log"	// in same directory as executable
#define LOG_BUFSIZE				32768

#define CONFIGFILENAME			"freeweb.ini"

#define MAX_FILES_PER_SITE		300				// approx number that'll fit into Freenet 32k manifest

#define DEFAULT_FCP_PORT		8082
#define DEFAULT_LISTEN_PORT		8888

#define DEFLOG_UI				LOG_DEBUG		// default logging thresholds
#define DEFLOG_FILE				LOG_DEBUG

#define PROGNAME				"FreeWeb"
#define HOPS_TO_LIVE			25

#define DOMAINNAMEMAXLEN		32
#define MAXDOMAINSPERUSER		32
#define MAXDIRLEN				80
#define MAXFILELEN				128

#define MAXUPDATEDAYSAHEAD		90	/* don't allow updates too far in advance */



#define CHKKEYLEN				128  /* not including 'CHK@' or '\0' */
