// 
//  This code is part of FreeWeb - an FCP-based client for Freenet
//
//  Designed and implemented by David McNab, david@rebirthing.co.nz
//  CopyLeft (c) 2001 by David McNab
//
//  The FreeWeb website is at http://freeweb.sourceforge.net
//  The website for Freenet is at http://freenet.sourceforge.net
//
//  This code is distributed under the GNU Public Licence (GPL) version 2.
//  See http://www.gnu.org/ for further details of the GPL.
//

// fwpubguiDlg.h : header file
//

#if !defined(AFX_FWPUBGUIDLG_H__2E998223_D393_4CEA_A536_D3F58559815F__INCLUDED_)
#define AFX_FWPUBGUIDLG_H__2E998223_D393_4CEA_A536_D3F58559815F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "sitelist.h"


/////////////////////////////////////////////////////////////////////////////
// CFwpubguiDlg dialog

class CFwpubguiDlg : public CDialog
{
// Construction
public:
	CFwpubguiDlg(CWnd* pParent = NULL);	// standard constructor
	void WriteStatus(char *msg);
	int UploadState;
	char selectedSite[128];
	int guiDisabled;
	int isShowing;

// Dialog Data
	//{{AFX_DATA(CFwpubguiDlg)
	enum { IDD = IDD_FWPUBGUI_DIALOG };
	CSiteList	m_SiteList;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFwpubguiDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CFwpubguiDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButUpdateAll();
	afx_msg void OnButUpdateSelected();
	afx_msg void OnButAddsite();
	afx_msg void OnButDeletesite();
	virtual void OnCancel();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnHelp();
	afx_msg void OnButAbout();
	afx_msg void OnButConfigure();
	afx_msg void OnEnable(BOOL bEnable);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnButtonHide();
	afx_msg void OnGateway();
	afx_msg void OnSiteprop();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FWPUBGUIDLG_H__2E998223_D393_4CEA_A536_D3F58559815F__INCLUDED_)
